## pure-gen-0.25.tar.gz

=== Makefile ===

# Package name and version number:
dist = pure-gen-$(version)
version = 0.25

# Installation goes into the following directories. You can also set these
# directly instead of $(prefix). In addition, packagers may want to set the
# DESTDIR variable for a staged install.

# Note that if you want to change the installation prefix, you'll have to set
# set the 'prefix' variable *both* at build and installation time, because the
# path to dump-ast gets hard-coded into the pure-gen executable.

# Alternatively, you can also set the DUMP_AST shell environment variable at
# runtime to tell pure-gen about the right path to the dump-ast executable.

prefix = $(shell pkg-config pure --variable prefix)
bindir = $(prefix)/bin
libdir = $(shell pkg-config pure --variable libdir)

pkgdatadir = $(libdir)/pure-gen
mandir = ${prefix}/share/man
man1dir = $(mandir)/man1

# Set GHCFLAGS to whatever additional ghc compilation flags are required on
# your platform. In particular, you'll want to set the linkage type to either
# -dynamic or -static, or leave it empty for the default (usually -static).
# Note that some systems (Arch) only ship with dynamic Haskell libraries these
# days. (But see below for static linkage on Arch.)
GHCFLAGS = -dynamic
#GHCFLAGS = -static

# Try to guess the host system type and do platform-specific setup.
host = $(shell ./config.guess)
gcc = gcc
ifneq "$(findstring -mingw,$(host))" ""
# Windows
EXE = .exe
# Windows uses the official packages which use static linking by default.
GHCFLAGS =
endif
ifneq "$(findstring -darwin,$(host))" ""
# OSX: Try to find a suitable gcc version to be used as the C preprocessor.
# The following assumes that a recent gcc version from MacPorts is installed.
# Note that we *really* need gcc (4.3+) here, pure-gen does *not* work when
# using clang (the system compiler on newer OS X versions) instead.
gcc = $(lastword gcc $(sort $(wildcard /opt/local/bin/gcc-mp-*)))
endif
ifneq "$(findstring x86_64-,$(host))" ""
# 64 bit, needs -fPIC flag
PIC = -fPIC
endif

DISTFILES = COPYING ChangeLog Makefile config.guess README README.dump-ast \
dump-ast.hs dump-ast-old.hs pure-gen.pure pure-gen.1 pure-gen.txt run-tests \
debian/* examples/*.templ language-c/*

# Always just do the maintainer build by default now. If you want the old
# default build target, run 'make all' instead.
default: maintainer-build

all: pure-gen dump-ast

# NOTE: This requires Pure 0.21 or later.

dump_ast = $(pkgdatadir)/dump-ast

pure-gen: pure-gen.pure
	sed -e 's?@version@?$(version)?' -e 's?@gcc@?$(gcc)?' -e 's?./dump-ast?$(dump_ast)?' < $< > xx$<
	pure $(PIC) $(PUREC_FLAGS) -c xx$< -o $@
	rm -f xx$<

# NB: This requires ghc (http://www.haskell.org/ghc/, version 6 or later) and
# language-c (https://hackage.haskell.org/package/language-c, version 0.4 or
# 0.5), please check the README for details. Any language-c versions later
# than 0.5 most likely won't work because of backward-incompatible changes in
# the library. (If you can figure out which changes are needed in dump-ast to
# compile against the latest version, please let me know!)

# If a suitable language-c version is not readily available, you can run this
# to install the included language-c 0.5.0 locally using cabal.
cabal-install:
	cd language-c && cabal v1-update && cabal v1-install

# These options work around quirks with various ghc versions.
GHCXFLAGS += -XTypeSynonymInstances -XFlexibleInstances
dump-ast: dump-ast.hs
	ghc $(GHCFLAGS) $(GHCXFLAGS) --make $< -o $@

# NB: If you're still running a really old language-c version like 0.3, then
# try compiling dump-ast-old.hs instead, it might work.

# dump-ast: dump-ast.hs dump-ast-old.hs
# 	ghc $(GHCFLAGS) $(GHCXFLAGS) --make $< -o $@ || \
# 	ghc $(GHCFLAGS) $(GHCXFLAGS) --make dump-ast-old.hs -o $@

# Alternative self-contained static build using the included language-c
# source, to make things easier for package maintainers. This requires that
# your ghc supports static linkage. NOTE: On Arch you'll have to install
# ghc-static and ghc-pristine (AUR) and make sure that
# /usr/share/ghc-pristine/bin comes first on PATH to make this work.
# Cf. https://wiki.archlinux.org/index.php/haskell#Static_linking.

# On Arch you want to have ghc-pristine installed and its ghc needs to be on
# the path, to make static builds work.
maintainer-build: export PATH := /usr/share/ghc-pristine/bin:$(PATH)

maintainer-build:
# Install locally into the build directory.
	cd language-c && HOME=$(shell pwd)/cabal cabal v1-update && HOME=$(shell pwd)/cabal cabal v1-install
# Make sure to do a static build here, since the cabal-installed language-c
# will be gone once we're finished.
	$(MAKE) all GHCFLAGS=-static HOME=$(shell pwd)/cabal
# Clean up.
	HOME=$(shell pwd)/cabal ghc-pkg unregister language-c
	rm -rf cabal language-c/dist

# Same as above, but without using cabal, which won't work on Launchpad where
# we don't have a working Internet connection.
deb-maintainer-build:
# Install locally into the build directory.
	cd language-c && mkdir -p $(shell pwd)/cabal && HOME=$(shell pwd)/cabal runhaskell Setup.hs configure --ghc --prefix=$(shell pwd)/cabal && HOME=$(shell pwd)/cabal runhaskell Setup.hs build && HOME=$(shell pwd)/cabal runhaskell Setup.hs install --user
# Make sure to do a static build here, since the locally installed language-c
# will be gone once we're finished.
	$(MAKE) all GHCFLAGS=-static HOME=$(shell pwd)/cabal
# Clean up.
	HOME=$(shell pwd)/cabal ghc-pkg unregister language-c
	rm -rf cabal language-c/dist

# Minimal test suite:

check:
	./run-tests $(gcc)

clean:
	rm -f pure-gen$(EXE) dump-ast$(EXE) *~ *.hi *.o
	rm -rf cabal language-c/dist

install:
	test -d "$(DESTDIR)$(bindir)" || mkdir -p "$(DESTDIR)$(bindir)"
	test -d "$(DESTDIR)$(pkgdatadir)" || mkdir -p "$(DESTDIR)$(pkgdatadir)"
	test -d "$(DESTDIR)$(man1dir)" || mkdir -p "$(DESTDIR)$(man1dir)"
	cp dump-ast$(EXE) "$(DESTDIR)$(pkgdatadir)"
	cp pure-gen$(EXE) "$(DESTDIR)$(bindir)"
# The binaries are huge, so better strip them.
	strip "$(DESTDIR)$(pkgdatadir)/dump-ast$(EXE)" "$(DESTDIR)$(bindir)/pure-gen$(EXE)"
ifeq "$(findstring -mingw,$(host))" ""
	chmod a+x "$(DESTDIR)$(pkgdatadir)/dump-ast$(EXE)" "$(DESTDIR)$(bindir)/pure-gen$(EXE)"
endif
	cp pure-gen.1 "$(DESTDIR)$(man1dir)"

uninstall:
	rm -rf "$(DESTDIR)$(bindir)/pure-gen$(EXE)" "$(DESTDIR)$(pkgdatadir)" "$(DESTDIR)$(man1dir)/pure-gen.1"

dist:
	rm -rf $(dist)
	mkdir $(dist) && mkdir $(dist)/debian && mkdir $(dist)/examples && mkdir $(dist)/language-c
	for x in $(DISTFILES); do ln -sf $$PWD/$$x $(dist)/$$x; done
	rm -f $(dist)/language-c/dist
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make && make check && make install DESTDIR=./BUILD
	rm -rf $(dist)

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://github.com/agraef/pure-lang/releases/download/pure-gen-$(version)/$(dist).tar.gz -O $@

=== debian/changelog ===
pure-gen (0.25-1) jammy; urgency=medium

  * New release.

 -- Albert Graef <aggraef@gmail.com>  Sun, 07 Aug 2022 18:45:38 +0200

pure-gen (0.24-1) jammy; urgency=medium

  * New release.

 -- Albert Graef <aggraef@gmail.com>  Fri, 05 Aug 2022 08:14:15 +0200

pure-gen (0.23-1) focal; urgency=medium

  * New release.

 -- Albert Graef <aggraef@gmail.com>  Fri, 01 May 2020 09:37:11 +0200

pure-gen (0.22-1) disco; urgency=medium

  * New release.

 -- Albert Graef <aggraef@gmail.com>  Fri, 16 Aug 2019 00:02:49 +0200

pure-gen (0.21-2) cosmic; urgency=medium

  * Work around Launchpad issues with the maintainer-build target. We
    don't have a working internet connection there, so the 2.x version of
    cabal-install won't work, and we have to directly invoke
    language-c/Setup.hs instead.

 -- Albert Graef <aggraef@gmail.com>  Mon, 29 Oct 2018 21:35:58 +0100

pure-gen (0.21-1) bionic; urgency=medium

  * Compile against the included language-c 0.5.0, as it is not available
    in Ubuntu any more, and link statically again.

 -- Albert Graef <aggraef@gmail.com>  Sat, 24 Feb 2018 15:58:30 +0100

pure-gen (0.20-3) artful; urgency=medium

  * Add runtime dependency libghc-language-c-dev, as the library is now
    linked dynamically in recent ghc versions

 -- Albert Graef <aggraef@gmail.com>  Mon, 11 Dec 2017 14:29:38 +0100

pure-gen (0.20-2) xenial; urgency=medium

  * Missing -fPIC flag (batch compilation)

 -- Albert Graef <aggraef@gmail.com>  Mon, 09 Jan 2017 09:29:51 +0100

pure-gen (0.20-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 25 Nov 2014 20:13:19 +0100

pure-gen (0.19-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 29 Oct 2014 01:51:06 +0100

pure-gen (0.18-2) trusty; urgency=low

  * Latest upstream fixes (PCRE compatibility)

 -- Albert Graef <aggraef@gmail.com>  Tue, 28 Oct 2014 23:54:19 +0100

pure-gen (0.18-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 17 Sep 2014 00:26:03 +0200

pure-gen (0.17-2) trusty; urgency=low

  * Upstream bugfix: pure-gen dumps core on illegal instruction, depending
    on the build host's cpu type. Prevent this by passing the
    -mcpu=generic option to llc when batch-compiling the script.

 -- Albert Graef <aggraef@gmail.com>  Mon, 15 Sep 2014 00:31:44 +0200

pure-gen (0.17-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Fri, 12 Sep 2014 12:37:09 +0200

pure-gen (0.16-1) precise; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Thu, 19 Sep 2013 08:17:29 +0200

pure-gen (0.15-5) natty; urgency=low

  * Make 'make check' work with newer gcc versions

 -- Albert Graef <Dr.Graef@t-online.de>  Sun, 02 Dec 2012 20:17:20 +0100

pure-gen (0.15-4) natty; urgency=low

  * Sync revision between distros

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 11:50:57 +0200

pure-gen (0.15-3) natty; urgency=low

  * Make the package compile with both Language.C 0.3.x and 0.4.x

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 09:52:46 +0200

pure-gen (0.15-2) natty; urgency=low

  * Dependency fixes

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 00:59:34 +0200

pure-gen (0.15-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Wed, 23 May 2012 07:43:35 +0200

=== debian/control ===
Source: pure-gen
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 9), pure, pure-dev, ghc, happy, alex, cabal-install, libghc-array-dev, libghc-base-dev, libghc-bytestring-dev, libghc-containers-dev, libghc-directory-dev, libghc-filepath-dev, libghc-pretty-dev, libghc-process-dev, libghc-syb-dev
Standards-Version: 3.9.1
Homepage: https://agraef.github.io/pure-lang/

Package: pure-gen
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gcc
Description: C bindings generator for the Pure programming language
 Pure is a modern-style functional programming language based on term
 rewriting. This package provides the pure-gen utility which can generate
 Pure bindings for C functions from C header files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	mkdir cabal
	dh_auto_build -- prefix=/usr PUREC_FLAGS=-mcpu=generic deb-maintainer-build

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params="--ignore-missing-info --warnings=0"
